﻿/*
 * Search declaration for pseudo namespace comprising search functions
 */
var Search = function() {};

Search.resultCount = 0;

Search.search = function(query, msgId, dstId, api, skip)
{
  var sobj = document.getElementById(msgId);
  var dobj = document.getElementById(dstId);
  if ((sobj == null) || (dobj == null)) return;
  if((typeof jQuery) != 'function')
  {
    alert(LocaleString.lcStrMessageNeedJQuery);
    return;
  }
  if (Search.indexData == null)
  {
    return;
  }
  //alert(Search.indexData.length);
  if ($('div#' + dstId).html() != '') return;
  Search.resultCount = 0;
  $('div#' + msgId).html(LocaleString.lcStrMessageSearching);
  var array = new Array(0);
  for (var n = 0; n < Search.indexData.length; n++)
  {
    var data = Search.indexData[n];
    if (data == null) continue;
    if (data.length < 4) continue;
    if (!api && (data[3] == 1)) continue
    var ret = Search.matchQuery(query, data, dstId, msgId);
    if (ret != null) array.push(ret);
  }
  array.sort(Search.resultSorter);
  // 
  while (skip > array.length) skip -= TemplateSettings.searchResultCountPerPage;
  if (skip < 0) skip = 0;
  for (var n = 0; n < array.length; n++)
  {
    var data = array[n];
    if (data == null) continue;
    if (data.length < 4) continue;
    if (n < skip) continue;
    var url = data[0];
    var title = data[1];
    url = Search.addQueryToURL(url, query, 'highlighttext');
    if ((url.length > 1) && (url[0] == "/")) url = url.slice(1);
    var ext = '';
    ext += '<p class="search_result_title">';
    //ext += '<a href="' + url + '">' + title + '</a><br />';
    ext += '<a href="' + url + '">' + title + '</a> (score: ' + data[3] + ')<br />';
    //ext += '(' + (n + 1) + ') ' + '<a href="' + url + '">' + title + '</a><br />';
    ext += '</p>';
    ext += '<p class="search_result_line">' + data[2] + '</p>';
    $('div#' + dstId).append($(ext));
    Search.resultCount++;
    if (Search.resultCount >= TemplateSettings.searchResultCountPerPage) break;
  }
  var msgBtn = '';
  if (skip > 0) msgBtn += (' <input type="button" onclick="btnClick(\'' + (skip - TemplateSettings.searchResultCountPerPage) + '\')" value="' + (LocaleString.lcStrLabelSearchPrev.replace('%c%', TemplateSettings.searchResultCountPerPage)) + '">');
  if ((skip + TemplateSettings.searchResultCountPerPage) < array.length) msgBtn += (' <input type="button" onclick="btnClick(\'' + (skip + TemplateSettings.searchResultCountPerPage) + '\')" value="' + (LocaleString.lcStrLabelSearchNext.replace('%c%', TemplateSettings.searchResultCountPerPage)) + '">');
  if (msgBtn != '') $('div#' + dstId).append($('<div>' + msgBtn + '</div'));

  var msg = '';
  msg += '<hr class="' + TemplateSettings.searchMessageLineStyle + '">';
  msg += (LocaleString.lcStrLabelSearchResult.replace('%r%', '' + array.length));
  if (array.length > 0) msg += (LocaleString.lcStrLabelSearchView.replace('%s%', '' + (skip + 1)).replace('%e%', '' + (skip + Search.resultCount)));
  msg += msgBtn;
  msg += '<hr class="' + TemplateSettings.searchMessageLineStyle + '">';
  
  $('div#' + msgId).html(msg);
}

Search.resultSorter = function (dataA, dataB)
{
  if (dataA[3] == dataB[3])
  {
    if (dataA[1] < dataB[1]) return -1;
    return 1;
  }
  return (dataB[3] - dataA[3]);
}

Search.addQueryToURL = function (url, query, word)
{
  if ((url == null) || (query == null)) return '';
  var posA = url.indexOf('?');
  var posB = url.indexOf('#');
  if (posB < 0) return (url + ((posA < 0) ? ('?' + word + '=') : ('&' + word + '=')) + encodeURIComponent(query));
  return (url.slice(0, posB) + ((posA < 0) ? ('?' + word + '=') : ('&' + word + '=')) + encodeURIComponent(query) + url.slice(posB));
}

Search.parseQuery = function (query)
{
  var array = query.split(' ');
  var ret = new Array(0);
  var start = 0;
  var flag = false;
  var invert = false;
  var work = '';
  while (start < array.length)
  {
    var str = array[start];
    if (!flag)
    {
      if (str.charAt(0) == '-')
      {
        str = str.slice(1);
        invert = true;
      }
      else
      {
        invert = false;
      }
    }
    else
    {
      work += ' ';
    }
    flag = Search.checkDQ(str, -1, flag);
    if (flag)
    {
      work += (str.replace(/"/g, ''));
    }
    else
    {
      work += (str.replace(/"/g, ''));
      ret.push((invert ? '\t' : '') + work);
      work = '';
    }
    start++;
  }
  //alert('[' + work + ']');
  if (work != '') ret.push((invert ? '\t' : '') + work);
  //alert(ret);
  return ret;
}

Search.checkDQ = function (str, pos, flag)
{
//  alert('str=' + str + ' pos=' + pos + ' flag=' + (flag ? 'T': 'F'));
  var ret = flag;
  var p = str.indexOf('"', (pos + 1));
  if (p >= 0)
  {
    ret = Search.checkDQ(str, p, !ret);
  }
  return ret;
}

Search.matchQuery = function (query, data, dstId, msgId)
{
  //var array = query.split(' ');
  var array = Search.parseQuery(query);
  var find = true;
  var rst = '';
  var filtered = data[2];
  var findPos = filtered.length;
  var onlyInvert = true;
  var findInvert = false;
  var score = 0;
  //alert('C:' + array.length + ' D:[' + array + ']');
  for (var n = 0; n < array.length; n++)
  {
    if (array[n] == '') continue;
    if (array[n].match(/^ +$/)) continue;
    var invert = false;
    var str = array[n];
    if (str.charAt(0) == '\t')
    {
      str = str.slice(1);
      if (str.match(/^ +$/)) continue;
      invert = true;
    }
    else
    {
      onlyInvert = false;
    }
    str = Search.escapeRegex(str);
    //alert(str);
    var re = new RegExp(str, 'i');
    var pos = filtered.search(re);
    var reS = new RegExp(str, 'ig');
    var match = filtered.match(reS);
    if (match != null)
    {
      score += match.length;
      //alert('match: [' + match + ']');
    }
    var flag = (pos >= 0);
    if (invert)
    {
      if (flag)
      {
        findInvert = true;
        find = false;
      }
    }
    else
    {
      if (findInvert) continue;
      find &= flag;
      if (!flag) continue;
      if (findPos > pos) findPos = pos;
    }
  }
  if ((find && !findInvert && !onlyInvert))
  //if ((find && !findInvert) || (onlyInvert && !findInvert))
  {
    //alert((onlyInvert ? 'only ' : '') + (findInvert ? 'invert ' : '') + (find ? 'find' : ''));
    if (findPos == filtered.length) findPos = 0;
    var start = findPos - TemplateSettings.searchResultDigestLength;
    if (start < 0) start = 0;
    //alert('f:' + findPos + ' s:' + start + ' l:' + filtered.length);
    rst = Search.escapeHtml(filtered.substr(start, TemplateSettings.searchResultDigestLength * 2));
    var url = data[0];
    var title = data[1];
    if ((url.length > 1) && (url[0] == "/")) url = url.slice(1);
    
    var ext = '';
    var strReg = '';
    for (var n = 0; n < array.length; n++)
    {
      if (array[n] == '') continue;
      if (array[n].match(/^ +$/)) continue;
      if (array[n].charAt(0) == '\t') continue;
      var str = Search.escapeRegex(array[n]);
      if (strReg != '') strReg += '|';
      strReg += str;
      //alert(str);
    }
    if (strReg != '')
    {
      var reR = new RegExp(strReg, 'ig');
      rst = rst.replace(reR, Search.highlighter);
    }
    ext += (((start > 0) ? '...' : '') + rst + (((start + TemplateSettings.searchResultDigestLength * 2) < filtered.length) ? '...' : '') + '<br />');
    return new Array(url, title, ext, score);
  }
  return null;
}

Search.highlighter = function (str)
{
  return ('<span class="search_highlight">' + str + '</span>');
}
/*
Search.escapeRegexSub = function (str)
{
  if (str == '\\') return '\\\\';
  return ('\\' + str);
}
*/
Search.escapeRegex = function (str)
{
  if (str == null) return '';
  if (typeof(str) != 'string') return '';
  var ret = str;
  ret = ret.replace(/\\/g, '\\\\');
  ret = ret.replace(/\^/g, '\\^');
  ret = ret.replace(/\$/g, '\\$');
  ret = ret.replace(/\./g, '\\.');
  ret = ret.replace(/\*/g, '\\*');
  ret = ret.replace(/\+/g, '\\+');
  ret = ret.replace(/\|/g, '\\|');
  ret = ret.replace(/\(/g, '\\(');
  ret = ret.replace(/\)/g, '\\)');
  ret = ret.replace(/\[/g, '\\[');
  ret = ret.replace(/\]/g, '\\]');
  ret = ret.replace(/\{/g, '\\{');
  ret = ret.replace(/\}/g, '\\}');
  ret = ret.replace(/\//g, '\\/');

  return ret;
}

Search.escapeHtml = function (html)
{
  if (html == null) return '';
  if (typeof(html) != 'string') return '';
  var ret = html;
  ret = ret.replace(/&/g, '&amp;');
  ret = ret.replace(/</g, '&lt;');
  ret = ret.replace(/>/g, '&gt;');
  ret = ret.replace(/"/g, '&quot;');
  ret = ret.replace(/\n/g, '<br />');
  ret = ret.replace(/\t/g, '&nbsp;&nbsp;');

  return ret;
}

Search.filterHtml = function (html)
{
  if (html == null) return '';
  if (typeof(html) != 'string') return '';
  var ret = html;
  ret = Search.removeTagAndText(ret, 'head');
  ret = Search.removeTagAndText(ret, 'noscript');
  ret = Search.removeTagAndText(ret, 'script');
  ret = Search.removeTagAndText(ret, 'style');
  ret = Search.extractTextFromTag(ret, 'pre', '', '', '', true);
  ret = ret.replace(/\n/g, '');
  ret = Search.extractTextFromTag(ret, 'div', 'class="(table|figure|code)"', '', '\n', false);
  ret = ret.replace(/<br( +[^>]*\/?>|>)/ig, '\n');
  ret = ret.replace(/<(th|td|dd)( +[^>]*>|>)/ig, '\t');
  ret = ret.replace(/<\/(h[1-6]|tr|p|ul|ol|dt|dd) *>/ig, '\n');
  ret = ret.replace(/<li( +[^>]*>|>)/ig, '\n');
/*
  ret = ret.replace(/<[^\/][^>]*>/g, '');
  ret = ret.replace(/<\/[^>]*>/g, '');
*/
  ret = ret.replace(/<[^>]*>/g, '');
  ret = ret.replace(/&lt;/ig, '<');
  ret = ret.replace(/&gt;/ig, '>');
  ret = ret.replace(/&quot;/ig, '"');
  ret = ret.replace(/&nbsp;/ig, ' ');
  ret = ret.replace(/&amp;/ig, '&');
  ret = ret.replace(/ +/g, ' ');
  ret = ret.replace(/ \n/g, '\n');
  ret = ret.replace(/\n+/g, '\n');

  return ret;
}

Search.removeTagAndText = function(html, tag)
{
  if (html == null) return '';
  if (typeof(html) != 'string') return '';
  if (tag == null) return '';
  if (typeof(tag) != 'string') return '';
  var ret = html;
  var pos = 0;
  //var reTagS = new RegExp('<' + tag + '>', 'i');
  var reTagS = new RegExp('<' + tag + '( +[^>]*>|>)', 'i');
  var reTagE = new RegExp('<\/' + tag + ' *>', 'i');
  while (pos >= 0)
  {
    pos = ret.search(reTagS);
    if (pos < 0) break;
    var matchS = ret.match(reTagS);
    var lenS = (matchS[0]).length;
    var work = ret.slice(pos + lenS);
    var epos = work.search(reTagE);
    if (epos < 0)
    {
      epos = pos + lenS;
      ret = ret.slice(0, pos) + ret.slice(epos);
    }
    else
    {
      var matchE = work.match(reTagE);
      var lenE = (matchE[0]).length;
      //alert('pos:' + pos + ' epos:' + epos + ' lenS:' + lenS + ' lenE:' + lenE + ' reTagS:' + ret.match(reTagS));
      ret = ret.slice(0, pos) + work.slice(epos + lenE);
    }
  }
  return ret;
}

Search.extractTextFromTag = function(html, tag, attr, before, after, convertLF)
{
  if (html == null) return '';
  if (typeof(html) != 'string') return '';
  if (tag == null) return html;
  if (typeof(tag) != 'string') return html;
  var strAttr = '';
  if ((attr != null) && (typeof(attr) == 'string')) strAttr = attr;
  var strBefore = '';
  if ((before != null) && (typeof(before) == 'string')) strBefore = before;
  var strAfter = '';
  if ((after != null) && (typeof(after) == 'string')) strAfter = after;
  var ret = html;
  var pos = 0;
  var reTagS = new RegExp('<' + tag + ((strAttr != '') ? (' ' + strAttr) : '') + '( [^>]*[^\/]>|>)', 'i');
  var reTagE = new RegExp('<\/' + tag + ' *>', 'i');
  while (pos >= 0)
  {
    pos = ret.search(reTagS);
    if (pos < 0) break;
    var matchS = ret.match(reTagS);
    var lenS = (matchS[0]).length;
    var work = ret.slice(pos + lenS);
    var epos = work.search(reTagE);
    if (epos < 0) break;
    var matchE = work.match(reTagE);
    var lenE = (matchE[0]).length;
    //alert('pos:' + pos + ' epos:' + epos + ' lenS:' + lenS + ' lenE:' + lenE + ' reTagS:' + ret.match(reTagS));
    if (convertLF)
    {
      ret = ret.slice(0, pos) + strBefore + work.slice(0, epos).replace(/\n/g, '<br />') + strAfter + work.slice(epos + lenE);
    }
    else
    {
      ret = ret.slice(0, pos) + strBefore + work.slice(0, epos) + strAfter + work.slice(epos + lenE);
    }
  }
  return ret;
}

