﻿/*
 * IDs used in JavaScript and other settings
 */
var TemplateSettings = function() {};

//
TemplateSettings.javaScriptPath       = 'template/js/common/';
TemplateSettings.templateLibFileName  = 'manualLib.js';
TemplateSettings.templateTocFileName  = 'tocData.js';
TemplateSettings.templateTitleFileName= 'title.html';
TemplateSettings.settingAttrId        = 'data-reassemble';
TemplateSettings.selectorTocFile      = 'script[src$="' + TemplateSettings.templateTocFileName + '"]';
TemplateSettings.documentRootPath     = 'contents/';

// Area where full table-of-contents tree is displayed.
TemplateSettings.divTreePaneId  = 'contents_tree';
TemplateSettings.styleTreePane  = 'treeitem_root';

// Icon image files used in full table of contents tree.
TemplateSettings.openIconPath   = 'template/img/icon_folder_open.png';
TemplateSettings.closeIconPath  = 'template/img/icon_folder_close.png';
TemplateSettings.fileIconPath   = 'template/img/icon_file.png';

// Style definitions for full table of contents tree
TemplateSettings.styleOpenTreeItemDiv   = 'treeitem_open';
TemplateSettings.styleCloseTreeItemDiv  = 'treeitem_close';
TemplateSettings.styleIconLineDiv       = 'listline';
TemplateSettings.styleNoIconLineDiv     = 'listline_file';
TemplateSettings.styleOpenTreeItemImg   = 'openfolder';
TemplateSettings.styleCloseTreeItemImg  = 'closefolder';
TemplateSettings.styleFileTreeItemImg   = 'file';
TemplateSettings.styleHeaderLineSpan    = 'header';
TemplateSettings.styleItemLineSpan      = 'item';
TemplateSettings.styleSeparatorLine     = 'separator';

// Attribute to configure full table of contents expanded/collapsed state
TemplateSettings.foldedTreeItemAttrId = 'data-folded';

// Full table of contents tab size settings
TemplateSettings.globalindexContentWidth  = 265;
TemplateSettings.globalindexToggleWidth   = 15;
TemplateSettings.globalindexPanePadH      = 32;

// Auto-generated table of contents tab size settings
TemplateSettings.autoindexContentWidth  = 250;
TemplateSettings.autoindexToggleWidth   = 15;
TemplateSettings.autoindexFocusOffset   = 15;
TemplateSettings.autoindexContentPadW   = 32;

// ID stuff
TemplateSettings.autoindexContentId       = 'autoindex_content';
TemplateSettings.autoindexWrapperId       = 'autoindex_wrapper';
TemplateSettings.autoindexTabId           = 'autoindex_tab';
TemplateSettings.autoindexToggleId        = 'autoindex_toggle';
TemplateSettings.autoindexToggleAttrId    = 'data-toggle';
TemplateSettings.globalindexWrapperId     = 'globalindex_wrapper';
TemplateSettings.globalindexTabId         = 'globalindex_tab';
TemplateSettings.globalindexToggleId      = 'globalindex_toggle';
TemplateSettings.globalindexToggleAttrId  = 'data-toggle';
TemplateSettings.globalindexRootPaneId    = 'rootPane';
TemplateSettings.titleLogoDivId           = 'logo';
TemplateSettings.titleTocDivId            = 'toc_title';
TemplateSettings.selectCategoryId         = 'selectCategory';
TemplateSettings.printControllerId        = 'printController';
TemplateSettings.treeControllerId         = 'treeController';

TemplateSettings.changeViewModeIdPrefix   = 'changeViewMode_';
TemplateSettings.expandDivIdPrefix        = 'Label_';
TemplateSettings.expandImgIdPrefix        = 'Img_';

// Style sheet stuff
TemplateSettings.styleAutoindexContent    = 'autoindex_content';
TemplateSettings.styleAutoindexWrapper    = 'autoindex_wrapper';
TemplateSettings.styleAutoindexTab        = 'autoindex_index';
TemplateSettings.styleAutoindexToggle     = 'autoindex_toggle';
TemplateSettings.styleAutoindexContent    = 'autoindex_content';
TemplateSettings.styleTitleLogoDiv        = 'logo';
TemplateSettings.styleTitleTocDiv         = 'toc_title';
TemplateSettings.styleSelectCategory      = 'selectCategory';

// For searching
TemplateSettings.searchFileName           = 'search.html';
TemplateSettings.searchBoxMiniFormName    = 'form_searchbox_mini';
TemplateSettings.searchBoxMiniDivId       = 'searchbox_mini';
TemplateSettings.searchBoxMiniDivStyle    = 'searchbox_mini_div';
TemplateSettings.searchBoxMiniTextStyle   = 'searchbox_mini_text';
TemplateSettings.searchBoxMiniButtonStyle = 'searchbox_mini_button';
TemplateSettings.searchMessageLineStyle   = 'search_message_line';
TemplateSettings.searchResultDigestLength = 100;
TemplateSettings.searchResultCountPerPage = 20;

// Cookie stuff
TemplateSettings.cookieKeyAutoindexToggle   = 'autoindexToggle';
TemplateSettings.cookieKeyGlobalindexToggle = 'globalindexToggle';
TemplateSettings.cookieKeyViewmode          = 'reassembleViewMode';

// For API
TemplateSettings.apiIframeId    = 'iframe_api';
TemplateSettings.apiIframePadW  = 4;
TemplateSettings.apiIframePadH  = 4;

// For Guidelines
TemplateSettings.guidelineDescIdPrefix      = 'description_';
TemplateSettings.guidelineDescLabelPrefix   = 'GuidelineDescLabel_';
TemplateSettings.guidelineDescAnchorPrefix  = 'Desc_';
TemplateSettings.guidelineItemIdPrefix      = 'itemDesc_';
TemplateSettings.guidelineItemLabelPrefix   = 'GuidelineItemLabel_';
TemplateSettings.guidelineItemAnchorPrefix  = 'guidelineitem_';

